-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-----                            DEALER.E                                 -----
-------------------------------------------------------------------------------
-------------------------------by THE REAPER-----------------------------------
------------------------ E-MAIL reaper@auracom.com ---------------------------- 
--send me comments, bugs, wishlists, complaints, and flame(well, maybe not). --
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-- DESCRIPTION: |                                                            --
-----------------                                                            --
--                                                                           --
-- ** EuDEALER **, the playing card engine for EUPHORIA!  With this handy    --
-- include file, you don't have to worry about loading 52 different .BMPs or --
-- using some other crazy method to display cards. You can use MY crazy      --
-- method!!! This loads the 52 different cards into memory, along with a card--
-- back for those face-down cards, so they can be easily displayed. It also  --
-- has some bonuses like changing the back of the cards with .BMPS, a card   --
-- shuffler, and a command to erase cards you don't want to display any      --
-- longer. Looks best in 640x480 mode, but is also nice (but big) in a       --
-- 320x200 mode. Check it out!!!                                             --
-------------------------------------------------------------------------------
-----------                                                                  --
-- USAGE: |                                                                  --
-----------                                                                  --
--                                                                           --
-- First, load the cards into memory (only needed once), by using the        --
-- loadcards(atom N).  N=0 to show the cards (needed for part-screen windows)--
-- or N=1 to hide the cards.                                                 --
--                                                                           --
-- To change what the back of the cards look like, you can load a .BMP file  --
-- using loadback(file BITMAP), where BITMAP is .BMP file no bigger than     --
-- 42x62.  [WARNING : Must be in a Graphic Mode!!!]                          --
--                                                                           --
-- To shuffle cards, use s = shuffle(atom N), where N is the number of packs --
-- you want shuffled. s will become a sequence of 52 (*N) values, each being --
-- a different card.                                                         --
--                                                                           --
-- To display a card, use drawcard(sequence LOC, sequence CARD), where LOC is--
-- the {x,y} where you want the card placed. CARD can be a recently shuffled --
-- value [EX... deck=shuffle(1) --THEN-- drawcard({50,50},deck[34]) ...].    --
-- CARD can also be a self-determined number, with format {suit,number}      --
-- [EX... drawcard({5,5},{CLUBS,ACE}) --OR-- drawcard({5,5},{SPADES,9}) ...].--
-- [WARNING: Must be in a Graphic Mode!]
--                                                                           --
-- To erase a card from the screen, use clearcard(sequence LOC, atom COLOR), --
-- where LOC is the {x,y} you had drawn the card in the first place, and     --
-- COLOR is the color you want to replace the card.                          --
--                                                                           --
-- To display a stack of cards, use S = showstack(sequence LOC, object N),   --
-- where LOC is the {x,y} you want the stack to be displayed, and N is either--
-- a sequence returned from shuffle(), or an atom of how many cards are left --
-- in the deck. sequence S will be sent a sequence of the stack's location in--
-- box format (ex. S = {{50,50},{100,100}}, which is the upper left and lower--
-- right cordinates of the stack). This is good for clearstack() and for     --
-- checking if the mouse clicked on it. [WARNING: Must be in Graphic Mode!]  --
--                                                                           --
-- To clear a stack of cards, use clearstack(sequence LOC, color N), where   --
-- LOC is the sequence returned from the showstack() command used to display --
-- the stack in the first place. N is the color you want to replace it.      --
-------------------------------------------------------------------------------

--***************************************************************************--

----INTIALIZE VARIABLES (or whatever)------------------------------------------

without type_check
without warning
include graphics.e
include file.e
include image.e
include wildcard.e
include carddata.e

atom x, y, nextcol
sequence place,cardface,prepack,cardpack,oldpack,cardpic,nextpic,deck,cardback,
	 cardface2,nextminipic
object spare
global constant HEARTS=1, DIAMONDS=2, CLUBS=3, SPADES=4, CARDBACK = {0,0},
		JACK=11, QUEEN=12, KING=13

cardface={}     --Basic Card Base
cardface=append(cardface, {10,10,10,0} & repeat(0,42) & {0,10,10,10})
cardface=append(cardface, {10,10,0} & repeat(15,44) & {0,10,10})
cardface=append(cardface, {10,0} & repeat(15,46) & {0,10})
for i = 1 to 64 do
cardface=append(cardface, 0 & repeat(15,48) & 0)
end for
cardface=append(cardface, {10,0} & repeat(15,46) & {0,10})
cardface=append(cardface, {10,10,0} & repeat(15,44) & {0,10,10})
cardface=append(cardface, {10,10,10,0} & repeat(0,42) & {0,10,10,10})

cardface2={}     --Basic Back Of Card
cardface2=append(cardface2, {10,10,10,0} & repeat(0,42) & {0,10,10,10})
cardface2=append(cardface2, {10,10,0} & repeat(12,44) & {0,10,10})
cardface2=append(cardface2, {10,0} & repeat(12,46) & {0,10})
for i = 1 to 64 do
cardface2=append(cardface2, 0 & repeat(12,48) & 0)
end for
cardface2=append(cardface2, {10,0} & repeat(12,46) & {0,10})
cardface2=append(cardface2, {10,10,0} & repeat(12,44) & {0,10,10})
cardface2=append(cardface2, {10,10,10,0} & repeat(0,42) & {0,10,10,10})

prepack={}
for i = 1 to 4 do
    for j = 1 to 13 do
	prepack = append(prepack,{i,j})    --set the cards up
    end for
end for

----Private Procedure----------------------------------------------------------

procedure draw(sequence loc, sequence card)    --used to create cards
    place=loc
    x=length(card[1])
    y=length(card)
    for i = 1 to y do
	place[2]=loc[2] + i - 1
	for j = 1 to x do
	    place[1]=loc[1] + j - 1
	    if card[i][j] != 10 then
		pixel(card[i][j],place)       --good masking routine
	    end if
	end for
    end for
end procedure

----Private Procedure----------------------------------------------------------

procedure putnumber(sequence loc, sequence num)  --used to put numbers on card
    place=loc
    for i = 1 to 16 do
	place[2]=loc[2] + i - 1
	for j = 1 to 8 do
	    place[1]=loc[1] + j - 1
	    if num[i][j] = 7 then
		pixel(nextcol,place)
	    end if
	end for
    end for
end procedure   
    
----DRAWCARD()-----------------------------------------------------------------

global procedure drawcard(sequence loc, sequence card)   --used to draw cards
    if not compare(card,CARDBACK) then
	draw(loc, cardback)              --can draw back of card
    else
	draw(loc, cardpic[card[1]][card[2]])
    end if
end procedure

----SHUFFLE()------------------------------------------------------------------

global function shuffle(atom howmany)        --used to shuffle a pack
    cardpack={}
    oldpack=prepack
    x=howmany-1
    if x > 0 then
	for i = 1 to x do
	    oldpack=oldpack & prepack         --can have multiple packs
	end for
    end if
    while length(oldpack) do                  --this randomizes a sequence
	y=rand(length(oldpack))
	cardpack=append(cardpack, oldpack[y])
	if y = 1 then
	    oldpack=oldpack[2..length(oldpack)]
	elsif y = length(oldpack) then
	    oldpack=oldpack[1..length(oldpack)-1]
	else
	    oldpack=oldpack[1..y-1] & oldpack[y+1..length(oldpack)]
	end if
    end while
    return cardpack
end function

----LOADBACK()-----------------------------------------------------------------

global procedure loadback(sequence bitmap)   --loads a .BMP for back of cards
    bitmap=upper(bitmap)
    x=0
    spare=dir(current_dir())
    for i = 1 to length(spare) do
	if not compare(bitmap,spare[i][1]) then   --check that BMP exists
	    x=1
	end if
    end for
    if x != 1 then
	x=graphics_mode(-1)        --tough luck
	puts(1, "Sorry, but a necessay .BMP file was not found.\n")
	puts(1, "Either this is a bug in the program, or there is\n")
	puts(1, "a important file missing.\n\n")
	abort(0)
    end if
    spare=save_image({0,0},{49,69})
    display_image({0,0},cardface2)
    oldpack=read_bitmap(bitmap)          --check size (no more than 42x62)
    if length(oldpack[2]) > 62 or length(oldpack[2][1]) > 42 then
	spare=graphics_mode(-1)
	puts(1, "Sorry, but that .BMP file is too big.\n\n")
	abort(0)
    end if
    x=floor((42-length(oldpack[2][1]))/2) + 4   --fit BMP to the center
    y=floor((62-length(oldpack[2]))/2) + 4
    display_image({x,y},oldpack[2])
    cardback=save_image({0,0},{49,69})     --save it
    display_image({0,0},spare)
end procedure   
    
----CLEARCARD()----------------------------------------------------------------

global procedure clearcard(sequence loc, atom color)  --used to erase a card
    polygon(color,1,{{loc[1],loc[2]},{loc[1],loc[2]+70},{loc[1]+50,loc[2]+70},
		     {loc[1]+50,loc[2]}}) 
end procedure
    
----SHOWSTACK()----------------------------------------------------------------

global function showstack(sequence loc,object howmany)  --display a card stack
    if atom(howmany) then
	x=howmany
    else
	x=length(howmany)
    end if
    y=floor(x/8)      --1 card is displayed for every eight left
    for i = 1 to y do
	drawcard({loc[1] + (2*i - 2),loc[2] + (1*i - 1)}, CARDBACK)
    end for
    x=loc[1]+50+(floor(x/8)*2-2)
    y=loc[2]+70+(floor(x/8)-6)
    spare={loc,{x,y}} --return x,y location
    return spare
end function   
    
----CLEARSTACK()---------------------------------------------------------------

global procedure clearstack(sequence loc, atom N)  --erases a displayed stack
    polygon(N,1,{loc[1],{loc[1][1],loc[2][2]},loc[2],{loc[2][1],loc[1][2]}})
end procedure    
    
----LOADCARDS()----------------------------------------------------------------

global procedure loadcards(atom show)     --loads the 52 cards into memory
    x=graphics_mode(13)          --mode for loading cards
    cardpic={{},{},{},{}}
    if show = 1 then
	puts(1,"LOADING CARDS...")
    end if
    set_active_page(show)                --hide the cards
    for i = 1 to 4 do
	if i = HEARTS then          --Set the card suit
	    nextpic=heart
	    nextcol=BRIGHT_RED
	    nextminipic=miniheart
	elsif i = DIAMONDS then
	    nextpic=diamond
	    nextcol=BRIGHT_RED
	    nextminipic=minidiamond
	elsif i = CLUBS then
	    nextpic=club
	    nextcol=BLACK
	    nextminipic=miniclub
	elsif i = SPADES then
	    nextpic=spade
	    nextcol=BLACK
	    nextminipic=minispade
	end if
	for j = 1 to 13 do                  --this draws ALL the cards
	    display_image({0,0},cardface)
	    if j < 11 then
		    putnumber({1,1},font[j][1])
		    putnumber({41,53},font[j][2])
		if j = 1 then
		    draw({20,30},nextpic)  --places the symbols
		elsif j = 2 then
		    draw({20,10},nextpic)
		    draw({20,50},nextpic)
		elsif j = 3 then
		    draw({20,10},nextpic)
		    draw({20,30},nextpic)
		    draw({20,50},nextpic)
		elsif j = 4 then
		    draw({8,10},nextpic)
		    draw({32,10},nextpic)
		    draw({8,50},nextpic)
		    draw({32,50},nextpic)
		elsif j = 5 then
		    draw({8,10},nextpic)
		    draw({32,10},nextpic)
		    draw({8,50},nextpic)
		    draw({32,50},nextpic)
		    draw({20,30},nextpic)
		elsif j = 6 then
		    draw({8,10},nextpic)
		    draw({8,30},nextpic)
		    draw({8,50},nextpic)
		    draw({32,10},nextpic)
		    draw({32,30},nextpic)
		    draw({32,50},nextpic)
		elsif j = 7 then
		    draw({8,10},nextpic)
		    draw({8,30},nextpic)
		    draw({8,50},nextpic)
		    draw({32,10},nextpic)
		    draw({32,30},nextpic)
		    draw({32,50},nextpic)
		    draw({20,20},nextpic)
		elsif j = 8 then
		    draw({8,10},nextpic)
		    draw({8,30},nextpic)
		    draw({8,50},nextpic)
		    draw({32,10},nextpic)
		    draw({32,30},nextpic)
		    draw({32,50},nextpic)
		    draw({20,20},nextpic)
		    draw({20,40},nextpic)
		elsif j = 9 then
		    draw({8,10},nextpic)
		    draw({8,20},nextpic)
		    draw({8,40},nextpic)
		    draw({8,50},nextpic)
		    draw({32,10},nextpic)
		    draw({32,20},nextpic)
		    draw({32,40},nextpic)
		    draw({32,50},nextpic)
		    draw({20,30},nextpic)
		elsif j = 10 then
		    draw({8,10},nextpic)
		    draw({8,20},nextpic)
		    draw({8,40},nextpic)
		    draw({8,50},nextpic)
		    draw({32,10},nextpic)
		    draw({32,20},nextpic)
		    draw({32,40},nextpic)
		    draw({32,50},nextpic)
		    draw({20,20},nextpic)
		    draw({20,40},nextpic)
		end if
	    elsif j = 11 then          --different procedure for face cards
		putnumber({1,1},font[j][1])
		putnumber({41,53},font[j][2])
		draw({20,10},nextpic)
		draw({10,23},jack)
		draw({20,50},nextpic)
	    elsif j = 12 then
		putnumber({1,1},font[j][1])
		putnumber({41,53},font[j][2])
		draw({20,10},nextpic)
		draw({10,23},queen)
		draw({20,50},nextpic)
	    elsif j = 13 then
		putnumber({1,1},font[j][1])
		putnumber({41,53},font[j][2])
		draw({20,10},nextpic)
		draw({10,23},king)
		draw({20,50},nextpic)
	    end if                           
	    draw({2,16},nextminipic[1])   --put miniature symbols on card
	    draw({43,50},nextminipic[2])
	    cardpic[i]=append(cardpic[i],save_image({0,0},{49,69})) --save card
	end for
    end for
    cardback=cardface2   --default card back  (solid BRIGHT_RED)
    x=graphics_mode(-1)
end procedure

---- T-T-THAT'S ALL FOLKS!!! (Yes, I know Porky Pig gets boring. Sue me.)------
